<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.controller' );

/**
 * fnetContent Controller
 *
 * @package Joomla
 * @subpackage fnetcontent
 */
class fnetContentControllerCustomscript extends fnetContentController {

	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
 
		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'unpublish', 	'publish');
	}
 
	/**
	 * display the edit form
	 * @return void
	 */
	function edit()
	{
		JRequest::setVar( 'view', 'customscript' );
		JRequest::setVar('hidemainmenu', 1);
 
		parent::display();
	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('customscript');
	
		if ($model->store()) {
			$msg = JText::_( 'Customscript Saved' );
		} else {
			$msg = JText::_( 'Error Saving customscript' );
		}
	
		// Check the table in so it can be edited.... we are done with it anyway
		$link = 'index.php?option=com_fnetcontent';
		$this->setRedirect($link, $msg);
	}
	
	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function apply()
	{
		$model = $this->getModel('customscript');
	
		if ($model->store()) {
			$msg = JText::_( 'Changes to customscript saved' );
		} else {
			$msg = JText::_( 'Error Saving customscript' );
		}
		$array = JRequest::getVar('cid',  0, '', 'array');
		$id = (int)$array[0];
		$this->setRedirect( 'index.php?option=com_fnetcontent&controller=customscript&task=edit&cid[]=' . $id, $msg );
	
	}
	
	/**
	 * publish a record (and redirect to main page)
	 * @return void
	 */
	function publish()
	{
		$publish = ( $this->getTask() == 'publish' ? 1 : 0 );
		$model = $this->getModel('customscript');
		if(!$model->publish($publish)) {
			$msg = JText::_( 'Error: One or More Customscripts Could not be Published/Unbublished' );
		} else {
			$msg = '';
		}
	
		$this->setRedirect( 'index.php?option=com_fnetcontent', $msg );
	}
	
	/**
	 * remove record(s)
	 * @return void
	 */
	function remove()
	{
		$model = $this->getModel('customscript');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or More Customscripts Could not be Deleted' );
		} else {
			$msg = JText::_( 'Customscript(s) Deleted' );
		}
	
		$this->setRedirect( 'index.php?option=com_fnetcontent', $msg );
	}
	
	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_fnetcontent', $msg );
	}
	
}