<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

defined('_JEXEC') or die('Restricted access');

/*
 * Define constants for all pages
*/

if(!defined('DS')){
	define('DS',DIRECTORY_SEPARATOR);
}
define('JV', (version_compare(JVERSION, '3', 'l')) ? 'j2' : 'j3');
define( 'COM_FNETCONTENT_DIR', 'images/'.'fnetcontent'.DS );
define( 'COM_FNETCONTENT_BASE', JPATH_ROOT.DS.COM_FNETCONTENT_DIR );
define( 'COM_FNETCONTENT_BASEURL', JURI::root().COM_FNETCONTENT_DIR );

// Set some global property
$document = JFactory::getDocument();
$cssFile = JURI::base(true).'/components/com_fnetcontent/assets/css/fnetcontent.css';
$document->addStyleSheet($cssFile, 'text/css', null, array());

$cssFile = JURI::root(true).'/media/com_fnetcontent/font-awesome/css/font-awesome.min.css';
$document->addStyleSheet($cssFile, 'text/css', null, array());
// Access check.
if (!JFactory::getUser()->authorise('core.manage', 'com_fnetcontent')) 
{
	throw new Exception(JText::_('JERROR_ALERTNOAUTHOR'));
}

// fnetcontent Helper
JLoader::register('FnetContentHelper', __DIR__ . '/helpers/fnetcontent.php');

// Old
// Require specific controller if requested
if($controller = JRequest::getWord('controller')) {
	require_once( JPATH_COMPONENT.'/controller.php' );
	$path = JPATH_COMPONENT.'/controllers/'.$controller.'.php';
	if (file_exists($path)) {
		require_once $path;
	} else {
		$controller = '';
	}
	// Initialize the controller
	$classname    = 'FnetContentController'.$controller;
	$controller   = new $classname( );
	// Perform the Request task
	$controller->execute( JRequest::getCmd('task'));
	$controller->redirect();
}
else {

	// New
	// Include dependancies
	jimport('joomla.application.component.controller');

	// Initialize the controller
	$controller	= JControllerLegacy::getInstance('FnetContent');
	$controller->execute(JFactory::getApplication()->input->get('task'));
	$controller->redirect();

}

function addSub($title, $v, $controller = null, $image = null) {

	$enabled = false;
	$view = JRequest::getWord("view", 'customscripts');
	if($view == $v) {
		$img = $v;
		if($image != null) {
			$img = $image;
		}
		JToolBarHelper::title(( 'fnetContent' )  .' - '. JText::_( $title), $img.'.png' );
		$enabled = true;
	}
	$link = 'index.php?option=com_fnetcontent&view='.$v;
	if($controller != null) {
		$link .= '&controller='.$controller;
	}
	JSubMenuHelper::addEntry( JText::_($title), $link, $enabled);
	
}