<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
 */

// No direct access
defined('_JEXEC') or die;

/**
 * Fnetcontent helper.
 */
class FnetContentHelper  extends JHelperContent
{
	public static $extension = 'com_fnetcontent';
	
    /**
	 * Configure the Linkbar.
	 *
	 * @param   string  $vName  The name of the active view.
	 *
	 * @return  void
	 *
	 * @since   1.6
	 */
    public static function addSubmenu($vName = '') {
		JHtmlSidebar::addEntry(
			JText::_('COM_FNETCONTENT_TITLE_SETTINGS'),
			'index.php?option=com_fnetcontent&view=settings',
			$vName == 'settings'
		);
		JHtmlSidebar::addEntry(
			JText::_('COM_FNETCONTENT_TITLE_FILEMANAGER'),
			'index.php?option=com_fnetcontent&view=filemanager',
			$vName == 'filemanager'
		);
		JHtmlSidebar::addEntry(
			JText::_('Applications'),
			'index.php?option=com_fnetcontent&view=',
			$vName == 'customscripts'
		);
    }
	
	/**
     * Gets a list of the actions that can be performed.
     *
     * @return	JObject
     * @since	1.6
     */
    public static function getActions($component = '', $section = '', $id = 0) {
        $user = JFactory::getUser();
        $result = new JObject;

        $assetName = 'com_fnetcontent';

        $actions = array(
            'core.admin', 'core.manage', 'core.create', 'core.edit', 'core.edit.own', 'core.edit.state', 'core.delete'
        );

        foreach ($actions as $action) {
            $result->set($action, $user->authorise($action, $assetName));
        }

        return $result;
    }
}
