<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

defined('_JEXEC') or die('Restricted access');

class com_fnetContentInstallerScript {

    /**
     * method to install the component
     *
     * @return void
     */
    function install($parent) {
        // $parent is the class calling this method
		$installSourcePath = dirname(__FILE__).'/';
		$installExt = array(
			'Modul fnetcontent' => 'modules/mod_fnetcontent',
			'Plugin fnetcontent' => 'plugins/fnetcontent',
			'Plugin fnetcustombackend' => 'plugins/fnetcustombackend',
			'Plugin fnetredirectfailedlogin' => 'plugins/fnetredirectfailedlogin',
			'Plugin fnetauth' => 'plugins/fnetauth'
		);
		
        // installing extensions
		foreach ($installExt as $extensionName => $extensionPath) {
			$extInstaller = new JInstaller;
			if ($extInstaller->install($installSourcePath.$extensionPath)) {
				echo $extensionName.' install success<br />';
			} else {
				echo $extensionName.' install failed', '<br />';
			}
		}

		// Enable extension in DB
        $db = JFactory::getDBO();
		
		// plugin fnetredirectfailedlogin only intall
		// enabling plugin fnetcustombackend
        $db->setQuery('update #__extensions set enabled = 1 where element = "fnetcustombackend" and folder = "system"');
        $db->query();
		
        // enabling plugin fnetcontent
//        $db->setQuery('update #__extensions set enabled = 1 where element = "fnetcontent" and folder = "system"');
//        $db->query();
		
		// Extra install todo's
		// Create directory /fnetcontent
		if (!file_exists(JPATH_ROOT.'/fnetcontent')) {
			mkdir(JPATH_ROOT.'/fnetcontent', 0777);
			file_put_contents(JPATH_ROOT.'/fnetcontent/index.html', '<html><body bgcolor="#FFFFFF"></body></html>');
		}
		
		// Create directory /fnetcontent
		if (!file_exists(JPATH_ROOT.'/fnetcontent/uploads')) {
			mkdir(JPATH_ROOT.'/fnetcontent/uploads', 0777);
			file_put_contents(JPATH_ROOT.'/fnetcontent/uploads/index.html', '<html><body bgcolor="#FFFFFF"></body></html>');
		}
		
		// Create directory /fnetcontent
		if (!file_exists(JPATH_ROOT.'/fnetcontent/clickdemo')) {
			mkdir(JPATH_ROOT.'/fnetcontent/clickdemo', 0777);
			if (!file_exists(JPATH_ROOT.'/fnetcontent/clickdemo/index.html')) {
				file_put_contents(JPATH_ROOT.'/fnetcontent/clickdemo/index.html', '<html><body bgcolor="#FFFFFF"></body></html>');
			}
		}
		
		// Weitere Dateien
		$files =array(
			array(
				'src' => $installSourcePath.'plugins/fnetauth/fnetauthLoginHelper.php',
				'dest'=> JPATH_ROOT.'/fnetcontent/fnetauthLoginHelper.php'
			)
		);
		$extInstaller->copyFiles($files);
	}
	
    /**
     * method to uninstall the component
     *
     * @return void
     */
    function uninstall($parent) {
        // $parent is the class calling this method

        $db = JFactory::getDBO();

        // uninstalling fnetcontent module
        $db->setQuery("select extension_id from #__extensions where name = 'mod_fnetcontent' and type = 'module' and element = 'mod_fnetcontent'");
        $fnetcontent_module = $db->loadObject();
        $module_uninstaller = new JInstaller;
        if($module_uninstaller->uninstall('module', $fnetcontent_module->extension_id)) {
            echo 'Module uninstall success', '<br />';
		} else {
            echo 'Module uninstall failed', '<br />';
        }

        // uninstalling fnetcontent plugin
        $db->setQuery("select extension_id from #__extensions where name = 'System - fnetContent' and type = 'plugin' and element = 'fnetcontent'");
        $fnetcontent_plugin = $db->loadObject();
        $plugin_uninstaller = new JInstaller;
        if($plugin_uninstaller->uninstall('plugin', $fnetcontent_plugin->extension_id)) {
            echo 'Plugin fnetContent uninstall success', '<br />';
		} else {
            echo 'Plugin fnetContent uninstall failed', '<br />';
		}
		
		// uninstalling fnetcustombackend plugin
        $db->setQuery("select extension_id from #__extensions where name = 'System - fnetCustomBackend' and type = 'plugin' and element = 'fnetcustombackend'");
        $fnetcontent_plugin = $db->loadObject();
        $plugin_uninstaller = new JInstaller;
        if($plugin_uninstaller->uninstall('plugin', $fnetcontent_plugin->extension_id)) {
            echo 'Plugin fnetCustomBackend uninstall success', '<br />';
		} else {
            echo 'Plugin fnetCustomBackend uninstall failed', '<br />';
		}

    }

    /**
     * method to update the component
     *
     * @return void
     */
    function update($parent) {
        // $parent is the class calling this method
    }

    /**
     * method to run before an install/update/uninstall method
     *
     * @return void
     */
    function preflight($type, $parent) {
        // $parent is the class calling this method
        // $type is the type of change (install, update or discover_install)
    }

    /**
     * method to run after an install/update/uninstall method
     *
     * @return void
     */
    function postflight($type, $parent) {
        // $parent is the class calling this method
        // $type is the type of change (install, update or discover_install)
    }
}