<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016. Alle Rechte vorbehalten.
 * @license     GNU General Public License Version 2 oder später; siehe LICENSE.txt
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

// Import Joomla! libraries
jimport( 'joomla.application.component.view');

class FnetContentViewCustomscripts extends JViewLegacy {
	function display($tpl = null) {
		FnetcontentHelper::addSubmenu('customscripts');
	
		// Get data from the model
		$items = $this->get( 'Data');
		$filter = $this->get('Filter');
		$pagination = $this->get('Pagination');

		$this->assignRef( 'items', $items );
		$this->assignRef('filter', $filter);
		$this->assignRef('pagination', $pagination);

		
		$this->addToolbar();
		$this->sidebar = JHtmlSidebar::render();
		parent::display($tpl);
	}

	/**
     * Add the page title and toolbar.
     *
     * @since	1.6
     */
	protected function addToolbar() {
		//toolbar
		JToolBarHelper::title(JText::_( 'formativ.net Content Customscripts' ), 'database');
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::addNew();
		JToolBarHelper::editList();
		JToolBarHelper::deleteList();
		//JToolBarHelper::help( 'screen.applications' );
		JToolBarHelper::preferences('com_fnetcontent');
		
//		JHtmlSidebar::addFilter(
//				JText::_('JOPTION_SELECT_PUBLISHED'),
//				'filter_published',
//				JHtml::_('select.options', JHtml::_('jgrid.publishedOptions'), 'value', 'text', $this->get('filter.published'), true)
//		);
	}
	
	/**
	 * Returns an array of fields the table can be sorted by
	 *
	 * @return  array  Array containing the field name to sort by as the key and display text as value
	 *
	 * @since   3.0
	 */
	protected function getSortFields()
	{
		return array(
				'm.published' => JText::_('JSTATUS'),
				'm.title' => JText::_('JGLOBAL_TITLE'),
				'm.path' => JText::_('Path'),
				'm.id' => JText::_('Id'),
		);
	}
}