<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

defined('_JEXEC') or die('Restricted access');

// Import library dependencies
jimport('joomla.plugin.plugin');
jimport('joomla.event.plugin');

class plgSystemfnetContent extends JPlugin {
	
	function __construct( &$subject ) {
		parent::__construct( $subject );
		// load plugin parameters and language file
		$this->_plugin = JPluginHelper::getPlugin( 'system', 'fnetcontent' );
		$this->_params = json_decode( $this->_plugin->params );
		JPlugin::loadLanguage('plg_system_fnetcontent', JPATH_ADMINISTRATOR);
	}

	/**
	 * Favicon upload
	 * Not final tested
	 */
	function onAfterInitialise() {
		$mainframe = JFactory::getApplication();
		// Nur ausführen wenn im Joomla Backend
		if($mainframe->isAdmin()) {
			
			$input    = JFactory::getApplication()->input;
			// Do not change the filter type 'raw'. We need this to let files containing PHP code to upload. See JInputFiles::get.
			$userfile = $input->files->get('jform', null, 'raw');
			if ($userfile){
				// Import filesystem libraries. Perhaps not necessary, but does not hurt
				jimport('joomla.filesystem.file');
				$filedata=$userfile['params']['newiconupload'];
				if ($filedata['error']==0 && $filedata['type']=='image/png'){
					$src = $filedata['tmp_name'];
					$params =$input->get('jform', array(), 'array');
					$templatepath=$params['params']['fnettemplatepath'];
					$dest = JPATH_ROOT.'/'.$templatepath.'/icons/newicon.png';
					JFile::upload($src, $dest);
				}
			}
		}
	}
	
	/**
	 * 
	 * @return boolean
	 */
    function onAfterRender() {
		$app = JFactory::getApplication();
		if($app->isAdmin()) {
			return;
		}
		$plugin = JPluginHelper::getPlugin('system', 'fnetcontent');
		$pluginParams = json_decode( $plugin->params );

		$content = JResponse::getBody();

		// expression to search for
		$regex = '/{(fnetcontent)\s*(.*?)}/i'; //BUG: des not work with written codes containing
		// if hide_code then replace fnetContent syntax codes with an empty string
		if ( $pluginParams->hide_code == 1 ) {
			$content = preg_replace( $regex, '', $content );
			return true;
		}

        $continuesearching = true;
        while ($continuesearching){  //Nesting loop
            // find all instances of $regex (i.e. fnetcontent) in an article and put them in $matches
            $matches = array();
            $matches_found = preg_match_all( $regex, $content, $matches, PREG_SET_ORDER );
            if ($matches_found) {
                // cycle through all fnetContent instancies. Put text into $dummy[2]
                foreach ($matches as $dummy) {
                    //read arguments contained in [] from $dummy[2] and put them into the array $fnetcontent
                    $mms=array();
                    $fnetcontent="";
                    preg_match_all('/\[.*?\]/', $dummy[2], $mms);
                    if ($mms) { //at the least one argument found
                        foreach ($mms as $i=>$mm) {
                            $fnetcontent = preg_replace("/\[|]/", "", $mm);
                        }
                    }

					//Following syntax {fnetcontent [storage_source][arg1]...[argN]}
                    $storage_source = $this->getStorageSource(trim(array_shift($fnetcontent)), $pluginParams->default_absolute_path); //filepathname or record id or ""
                    $output = ''; // fnetContent output

                    if($storage_source == '') { //if nothing to show
                        $output = '<div style="color:#FF0000;background:#FFFF00;">'.JText::_('PLG_FNETCONTENT_ERROR_CONTENT').'</div>';
                    } else { // buffer output
                        ob_start();
                        if(is_int($storage_source)){ //it is record id
                      $code_stored = $this->getCodeStored($storage_source);
                    if($code_stored != null){ //include custom script written
                                eval ('?>'.$code_stored);
                    } else {
                                $output = '<div style="color:#FF0000;background:#FFFF00;">'.JText::sprintf('PLG_FNETCONTENT_ERROR_RECORD', $storage_source).'</div>';
                    }
                } else { //it is file
                    if(is_readable($storage_source)) {
                                include($storage_source); //include file
                    } else {
                                $output = '<div style="color:#FF0000;background:#FFFF00;">'.JText::sprintf('PLG_FNETCONTENT_ERROR_FILE', $storage_source).'</div>';
                    }
                        }
                if ($output == ''){ //if there are no errors
                    //$output = str_replace( '$' , '\$' , ob_get_contents()); fixed joomla bug
                    $output = ob_get_contents();
                }
                    ob_end_clean();
                }

                // final replacement of $regex (i.e. {fnetcontent [][]}) in $article->text by $output
                    $content = preg_replace($regex, $output, $content, 1);
                }
                if ($pluginParams->nested_replace == 0) {
                    $continuesearching = false;
                }
            } else {
                $continuesearching = false;
            }
        }
        JResponse::setBody($content);
    }

	/**
	 * returns code stored in the database or null.
	 * @param type $source
	 * @return type
	 */
    function getCodeStored($source) {
        $database  = JFactory::getDBO();
        $database->setQuery("select custom_script from #__fnetcontent where id = $source");
        return $database->loadResult();
    }

	/**
	 * returns filepathname or a record id or ""
	 * @param type $source
	 * @param type $abspath
	 * @return string
	 */
    function getStorageSource($source, $abspath) {
        $storage=trim($source);
        if ($storage!=""){
            if ($id = substr(strchr($storage,"*"),1)) { //if record id return it
                return (int)$id;
            } else { // else return filepathname
                if ($abspath == '')
                    return $storage;
                else
                    return $abspath.DS.$storage;
            }
        } else {
            return '';
        }
    }

}