<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent / Joomla.Legacy
 * @subpackage  View
 * @copyright   Copyright (C) 2016 formativ.net. All rights reserved.
 * @license     GNU General Public License Version 2 oder später; siehe LICENSE.txt
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
 */

defined('JPATH_PLATFORM') or die;

/**
 * HTML View case class for the fnetContent component
 *
 * Class holding methods for displaying presentation data.
 *
 * @since  1.0.1
 */

class fnetContentViewLegacy extends JViewLegacy 
{	
	protected $params;
	protected $appl;
	protected $applicationParams;
	protected $applicationRoute;
	protected $viewfile;
	protected $fnetapplication;
	protected $fnetContentParams;
	
	/**
	 * Constructor
	 *
	 * @param   array  $config  JViewLegacy
	 *
	 * @since   12.2
	 */
	public function __construct($config = array())
	{
		parent::__construct($config);
		$app	= JFactory::getApplication();
		$this->params = $app->getParams();
		// Get the parameters
		$this->fnetContentParams = JComponentHelper::getParams('com_fnetcontent');
	}
	
	/**
	 * 
	 * @param string $params
	 * @return array
	 */
	protected function _prepareParamsArray($params){
		$ret= json_decode($params);
		return $ret;
	}
	
	/**
	 * Erzeugt die globale Variable $formativnetApp und legt die Parameter des Menüpunktes in diesem ab
	 */
	 protected function _prepareGlobalsFnet() {
		global $formativnetApp;
		
		$formativnetApp['applicationParam'][0]=$this->applicationRoute;

		$applicationParams = \json_decode($this->params->get('applicationParamsArray', NULL));
		if ($applicationParams) {
			foreach($applicationParams->appParamKey as $key => $value) {
				if($value==''){ $value=$key+1; }
				$formativnetApp['applicationParam'][$value]=$applicationParams->appParamValue[$key];
			}
		}
		$app = JFactory::getApplication();
		$formativnetApp['menueData']=$app->getMenu()->getActive();
		$formativnetApp['viewfile']=$this->viewfile;
		$formativnetApp['applicationInfo']=$this->fnetapplication;
		$formativnetApp['applicationRoute']=$this->applicationRoute;
		$formativnetApp['fnetContentParams']=$this->fnetContentParams;
		$formativnetApp['view']=$this->params;
		$formativnetApp['document']=$this->document;
	}
	
	/**
	 * Wird von den Komponenten Views aufgerufen um die Parameter des Menüpunktes an das aufzurufende Script zu übergeben
	 * Über $format kann gesteuert werden wie die Übergabe erfolgt.  ist 'fnet'
	 * Ist $format='fnet' (Standard) so wird die funktion _prepareGlobalsFnet um die
	 * globale Variable $formativnetApp zu erzeugen, in der alle Parameter abgelegt sind.
	 * Aktuell gibt es nur das Format 'fnet' 
	 * 
	 * @param string $format Default 'fnet'
	 */
	 protected function prepareGlobalsVars($format='fnet') {
		
		switch ($format) {
			case 'fnet': $this->_prepareGlobalsFnet(); break;

			default:
				$this->_prepareGlobalsFnet();
				break;
		}
	}
}