<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

// No direct access
defined('_JEXEC') or die;

jimport('joomla.application.component.view');

class fnetContentViewContact extends fnetContentViewLegacy
{
	public $formData = array();
	
	/**
	 * Views Ausgabe vorbereiten und Event "onContentPrepare" für 
	 * Joomla Content-Plugins triggern 
	 * @param type $tpl
	 * @return \Exception
	 */
	public function display($tpl = null)
	{
		// Globale Variablen aufbereiten und setzen
		$this->prepareGlobalsVars();
		
		//$this->prepareData();
		$this->_prepareDocument();

		//parent::display($tpl);
		
		$result = new stdClass;
		$result->text = $this->loadTemplate($tpl);

		// add more to parameters if needed
		$params = new JObject;
		
		if ($result instanceof Exception)
		{
			return $result;
		} else {
			JPluginHelper::importPlugin('content');
			$dispatcher = JDispatcher::getInstance();
			$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$result, &$params, 0));
		}
		echo $result->text;
	}
	
	/**
	 * 
	 * @param type $fieldname Name des HTML Formularfeldes
	 * @return string
	 */
	public function getFormValue($fieldname, $default='',$filter='STRING') {
		$jinput = JFactory::getApplication()->input;
		return $jinput->post->get($fieldname,$default, $filter);
	}
	
	/**
	 * 
	 * @param type $fieldname Name des HTML Formularfeldes
	 * @param type $checkvalue
	 * @return string
	 */
	public function isChecked($fieldname, $checkvalue) {
		$jinput = JFactory::getApplication()->input;
		if ($jinput->post->get($fieldname,'', 'STRING') == $checkvalue) {
			return 'checked="checked"';
		}
		else {
			return '';
		}
	}
	
	/**
	 * 
	 * @param type $fieldname Name des HTML Formularfeldes
	 * @param type $checkvalue
	 * @return string
	 */
	public function isSelected($fieldname, $checkvalue) {
		$jinput = JFactory::getApplication()->input;
		if ($jinput->post->get($fieldname,'', 'STRING') == $checkvalue) {
			return 'selected="selected"';
		}
		else {
			return '';
		}
	}
	
	
	/**
	 * Ersetzt "{PLATZHALTER}" in $content mit den Formular Werten die per Post gesendet wurden
	 * PLATZHALTER = Feldname in Grossbuchstaben
	 * @param string $content Text in dem die Plathalter ersetzt werden
	 * @return string
	 */
	public function substituteFormData($content='') {
		$jinput = JFactory::getApplication()->input;
		$this->formData = $jinput->post->getArray();
		if ($content!=='') {
			foreach( $this->formData as $fieldname => $value) {
				// Feldnamen bereinigen
				$fieldname = preg_replace("/[^0-9a-zA-Z_]/",'', strip_tags($fieldname) );
				// Werte verarbeiten und bereinigen
				if(is_array($value)){
					$temp='';
					foreach( $value as $key => $tempval) {
						$key = preg_replace("/[^0-9a-zA-Z_]/",'_', strip_tags($key) );
						$temp .=$fieldname.'['.$key.'] : '.$tempval;
					}
					$value = $temp;
				}
				$value = strip_tags($value);
				
				//Platzhalter ersetzen
				$content = str_replace('{'.strtoupper($fieldname).'}', $value, $content);
			}
		}
		return $content;
	}
	
	/**
	 * Konvertiert die per Post gesendeten Formular-Daten in ein String
	 * @return string 
	 */
	public function formDataToString() {
		$content='Form values'."\n\n";
		$jinput = JFactory::getApplication()->input;
		$this->formData = $jinput->post->getArray();
		foreach( $this->formData as $fieldname => $value) {
			// Feldnamen und Werte bereinigen
			$fieldname = preg_replace("/[^0-9a-zA-Z_]/",'', strip_tags($fieldname) );
			$value = strip_tags($value);
			$content .= $fieldname.' : '.$value."\n";
		}
		return $content;
	}
	
	/** 
	 * Löscht überflüssige Whitespace Zeichen aus den übergebenen String
	 * Z.B. Doppelte Leerzeichen
	 * @param string $string
	 * @return string
	 */
	function cleanWhitespace($string) {
		return trim( preg_replace('/\s+/', ' ', $string) );
	}
	
	/**
	 * Formulardaten per E-Mail an Seitenbetreiber senden
	 * @param type $mailfrom E-Mail des Absenders
	 * @param type $mailfromname Name des Absenders
	 */
	public function sendContactMail($mailfrom='',$mailfromname='') {
		$config = JFactory::getConfig();
		$mailer = JFactory::getMailer();
		// Zeichen Filtern
		$mailfrom = trim( str_replace(array("\r","\n","\0"),array(' ',' ',' '),$mailfrom) );
		$mailfromname = trim( str_replace(array("\r","\n","\0"),array(' ',' ',' '),$mailfromname) );
		
		// Nur absenden wenn ein Empfänger ermittelt werden kann
		// 1. Menü-Einstellung 
		// 2. Joomla Konfiguration
		if ( $this->params->get('mailto',$config->get( 'mailfrom' ))!='') {
			$mailer->addRecipient(
					$this->params->get('mailto',$config->get( 'mailfrom' )),
					$this->params->get('mailtoname',$config->get( 'fromname' ))	
				);
			if ($this->params->get('mailfromsender', 0 )==0 ) {
				$mailer->setSender(
						$config->get( 'mailfrom' ),
						$config->get( 'fromname' )
					);
			}
			else {
				$mailer->setSender( $mailfrom, $mailfromname );
			}
			
			$mailer->setSubject( $this->substituteFormData( $this->params->get('mailsubject', 'Contactform - '.$config->get('sitename') ) ) );
			$mailBody = $this->params->get('mailbody','');
			if ($mailBody=='') {
				$mailBody = $this->formDataToString();
			} else {
				$mailBody = $this->substituteFormData($mailBody);
			}
			$mailer->setBody($mailBody);
			$mailer->Send();
		}
	}
	
	/**
	 * Feedback per E-Mail an Besucher senden
	 * @param type $mailto E-Mail des Empfängers
	 * @param type $mailtoname Name des Empfängers
	 */
	public function sendFeedbackMail($mailto='',$mailtoname='') {
		// Zeichen Filtern
		$mailto = trim( str_replace(array("\r","\n","\0"),array(' ',' ',' '),$mailto) );
		$mailtoname = trim( str_replace(array("\r","\n","\0"),array(' ',' ',' '),$mailtoname) );
		if (
			( $this->params->get('feedbacksendmail',0) == 1 )
			and ($mailto!='')
		) {
			$config = JFactory::getConfig();
			$mailer = JFactory::getMailer();
			$mailer->setSender(
					$this->params->get('feedbackmailfrom',$config->get( 'mailfrom' )),
					$this->params->get('feedbackmailname',$config->get( 'fromname' ))
				);
			$mailer->addRecipient($mailto,$mailtoname);
			$mailer->setSubject( $this->substituteFormData( $this->params->get('feedbackmailsubject', 'Contactform - '.$config->get('sitename')) ) );
			$mailer->setBody( $this->substituteFormData( $this->params->get('feedbackmailbody','Vielen Dank für Ihre Anfrage!'."\n".'Wir setzen uns so schnell wie möglich mit Ihnen in Verbindung.') ) );
			$mailer->Send();
		}
	}
	
	/**
	 * Prepares the document
	 *
	 * @return  void.
	 */
	protected function _prepareDocument()
	{
		$app   = JFactory::getApplication();
		$menus = $app->getMenu();

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();

		if ($menu)
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		$title = $this->params->get('page_title', '');

		if (empty($title))
		{
			$title = $app->get('sitename');
		}
		elseif ($app->get('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
		}
		elseif ($app->get('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
		}

		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description'))
		{
			$this->document->setDescription($this->params->get('menu-meta_description'));
		}

		if ($this->params->get('menu-meta_keywords'))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		}

		if ($this->params->get('robots'))
		{
			$this->document->setMetadata('robots', $this->params->get('robots'));
		}
	}
}
