<?php
/**
 * @version     1.0.4
 * @package     com_fnetcontent
 * @copyright   Copyright (C) 2016 formativ.net oHG. Alle Rechte vorbehalten.
 * @license     GNU General Public License http://www.gnu.org/licenses/gpl.html
 * @author      thomas Langer <langer@formativ.net> - http://www.formativ.net
*/

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.view');

/**
 * HTML Contact View class for the Contact component
 *
 * @package     Joomla.Site
 * @subpackage  com_contact
 * @since       1.5
 */

class fnetContentViewFnetapplication extends fnetContentViewLegacy {

	
	function display($tpl = null) {
		
		$this->fnetapplicationpath = trim($this->params->get('fnetapppath','fnetcontent/index.php'));
		$this->applicationRoute = trim($this->params->get('approute',''));
		
		// Globale Variablen aufbereiten und setzen
		$this->prepareGlobalsVars();
		
		$this->_prepareDocument();
		
		//parent::display($tpl);
		
		$result = new stdClass;
		$result->text = $this->loadTemplate($tpl);

		// add more to parameters if needed
		$params = new JObject;
		
		if ($result instanceof Exception)
		{
			return $result;
		} else {
			JPluginHelper::importPlugin('content');
			$dispatcher = JDispatcher::getInstance();
			$dispatcher->trigger('onContentPrepare', array ('com_content.article', &$result, &$params, 0));
		}
		echo $result->text;
	}
	
	
	
	/**
	 * Prepares the document
	 *
	 * @return  void.
	 */
	protected function _prepareDocument()
	{
		$app   = JFactory::getApplication();
		$menus = $app->getMenu();
		$title = null;

		// Because the application sets a default page title,
		// we need to get it from the menu item itself
		$menu = $menus->getActive();

		if ($menu)
		{
			$this->params->def('page_heading', $this->params->get('page_title', $menu->title));
		}
		else
		{
			$this->params->def('page_heading', JText::_('JGLOBAL_ARTICLES'));
		}

		$title = $this->params->get('page_title', '');

		if (empty($title))
		{
			$title = $app->get('sitename');
		}
		elseif ($app->get('sitename_pagetitles', 0) == 1)
		{
			$title = JText::sprintf('JPAGETITLE', $app->get('sitename'), $title);
		}
		elseif ($app->get('sitename_pagetitles', 0) == 2)
		{
			$title = JText::sprintf('JPAGETITLE', $title, $app->get('sitename'));
		}

		$this->document->setTitle($title);

		if ($this->params->get('menu-meta_description'))
		{
			$this->document->setDescription($this->params->get('menu-meta_description'));
		}

		if ($this->params->get('menu-meta_keywords'))
		{
			$this->document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		}

		if ($this->params->get('robots'))
		{
			$this->document->setMetadata('robots', $this->params->get('robots'));
		}
	}
}